function manifest()
	myManifest = {
		name          = "faker",
		comment       = "convert note interval to pich control data.",
		author        = "function",
		pluginID      = "{4cd8aada-74b1-4aab-9990-e1caf3e5191f}",
		pluginVersion = "0.2.0.3",
		apiVersion    = "3.0.5.0"
	}
	return myManifest
end
function readIni(filename)
	local f = io.open(filename,"r")
	local ret
	local data = ""
	for line in f:lines() do
		if line:find("=") ~= nil then
			data = data..line..","
		end
	end
	f:close()
	data = data:sub(1,#data-1)
	return loadstring('return {'..data..'}')()
end
function execLog(s)
	if (cnf.LOG_OUTPUT == true) then
		local f = io.open(scriptDir..manif.name..".log","a")
		f:write(s.."\n")
		f:close()
	end
end
function getNoteName(noteNum)
	local letter = {"C","C#","D","D#","E","F","F#","G","G#","A","A#","B"}
	local num = tonumber(noteNum)
	local lnum = (math.floor(num/12))-2
	local lmod = math.mod(noteNum,12)
	return letter[lmod+1]..lnum
end
function splitEx(str, delim)
	if (str:find(delim)==nil) then
		return {str}
	end
	local result = {}
	local pat = "(.-)"..delim.."()"
	local lastPos
	for part, pos in str:gfind(pat) do
		table.insert(result,part)
		lastPos = pos
	end
	table.insert(result,str:sub(lastPos))
	return result
end
function round(num)
	local lower = math.floor(num)
	local upper = math.floor(num) + 1
	local lowDiff = -(lower-num)
	local upDiff = upper-num
	if (upDiff>lowDiff) then
		return lower
	else
		return upper
	end
end
function getRatioParam()
	local ratioMode = {}
	ratioMode[1] = {no=5, name='mid'      , tick='mid' ,val='mid' }
	ratioMode[2] = {no=1, name='fast'     , tick='fast',val='fast'}
	ratioMode[3] = {no=2, name='mid-fast' , tick='mid' ,val='fast'}
	ratioMode[4] = {no=3, name='slow-fast', tick='slow',val='fast'}
	ratioMode[5] = {no=4, name='fast-mid' , tick='fast',val='mid' }
	ratioMode[6] = {no=6, name='slow-mid' , tick='slow',val='mid' }
	ratioMode[7] = {no=7, name='fast-slow', tick='fast',val='slow'}
	ratioMode[8] = {no=8, name='mid-slow' , tick='mid' ,val='slow'}
	ratioMode[9] = {no=9, name='slow'     , tick='slow',val='slow'}
	return ratioMode
end
function getRatioConstVal(str)
	local pramKind = {fast=cnf.CURVE_KIND_FAST, mid=cnf.CURVE_KIND_MID, slow=cnf.CURVE_KIND_SLOW}
	for key,val in pairs(pramKind) do
		if ( str == key) then
			return val
		end
	end
	return nil
end
function getRatio(aboveNum, belowNum)
	local param = {}
	for i =1, #ratioMode do
		if (ratioMode[i].no == aboveNum) then
			param.CURVE_ABOVE_TICK_RATIO = getRatioConstVal(ratioMode[i].tick)
			param.CURVE_ABOVE_VALUE_RATIO = getRatioConstVal(ratioMode[i].val)
		end
		if (ratioMode[i].no == belowNum) then
			param.CURVE_BELOW_TICK_RATIO = getRatioConstVal(ratioMode[i].tick)
			param.CURVE_BELOW_VALUE_RATIO = getRatioConstVal(ratioMode[i].val)
		end
	end
	return param
end
function getTargetData()
	local notes = {}
	local note, retCode
	local flg = 0
	local i = 1
	VSSeekToBeginNote()
	retCode, note = VSGetNextNote()
	while (retCode == 1) do
		if (beginPosTick <= note.posTick) and (note.posTick < endPosTick) then
			notes[i] = note
			i = i + 1
		elseif (note.posTick >= endPosTick) then
			if (flg == 0) then
				notes[i] = note
				i = i + 1
				flg = 1
			else
				break
			end
		end
		retCode, note = VSGetNextNote()
	end
	return flg, notes, j
end
function selKeynoteDialog()
	local field = {}
	local dd, state, selNum, ret
	local retKeyNote, retAboveNum, retBelowNum, retCurveDuration
	VSDlgSetDialogTitle("target  "..#notes-nextSectionFlg.."  notes. start this job plugin ?")
	field.name = "keynote"
	field.caption = "select keynote.  number ="
	dd = ""
	for i = 1, #notes-nextSectionFlg do
		dd = dd.."No."..i.." "..getNoteName(notes[i].noteNum)..","
	end
	field.initialVal = dd:sub(1,#dd-1)
	field.type = 4
	state = VSDlgAddField(field)
--[[
	field.name = "aboveCurve"
	field.caption = "select curve type. on notes interval above="
	dd = ""
	for i = 1, #ratioMode do
		dd = dd.."No."..ratioMode[i].no.." "..ratioMode[i].name..","
	end
	field.initialVal = dd:sub(1,#dd-1)
	field.type = 4
	state = VSDlgAddField(field)
	field.name = "belowCurve"
	field.caption = "select curve type. on notes interval above="
	dd = ""
	for i = 1, #ratioMode do
		dd = dd.."No."..ratioMode[i].no.." "..ratioMode[i].name..","
	end
	field.initialVal = dd:sub(1,#dd-1)
	field.type = 4
	state = VSDlgAddField(field)
--]]
	field.name = "curveDuration"
	field.caption = "select curve type ="
	dd = cnf.CURVE_TICK_MAX_CHOOSE
	field.initialVal = dd
	field.type = 4
	state = VSDlgAddField(field)
	state = VSDlgDoModal()
	if (state == 2) then
		return 0
	end
	if ((state ~= 1) and (state ~= 2)) then
		return 0
	end
	state, ret = VSDlgGetStringValue("keynote")
	selNum = splitEx(ret," ")
	retKeynote = tonumber(string.sub(selNum[1],4,#selNum[1]))
--[[
	state, ret = VSDlgGetStringValue("aboveCurve")
	selNum = splitEx(ret," ")
	retAboveNum = tonumber(string.sub(selNum[1],4,#selNum[1]))
	state, ret = VSDlgGetStringValue("belowCurve")
	selNum = splitEx(ret," ")
	retBelowNum = tonumber(string.sub(selNum[1],4,#selNum[1]))
--]]
	retAboveNum = 1
	retBelowNum = 1
	state, ret = VSDlgGetStringValue("curveDuration")
	retCurveDuration = tonumber(ret)
	return retKeynote, retAboveNum, retBelowNum, retCurveDuration
end
function checkInterval()
	local mostIntv = 0
	for i = 1, #notes-nextSectionFlg do
		local intv = math.abs(keynoteNum - notes[i].noteNum)
		mostIntv = math.max(intv,mostIntv)
	end
	if (mostIntv > cnf.PBS) then
		return 1
	end
	return 0
end
function getNextSection()
	local nextSection = {}
	if (nextSectionFlg < 1) then
		return nil
	else
		for i = 1, #ctrlKind do
			local info = {}
			local ret, val
			info.ctrlKind = ctrlKind[i]
			info.posTick = notes[#notes].posTick
			ret, val = VSGetControlAt(info.ctrlKind,info.posTick)
			info.ctrlValue = val
			execLog(string.format("getNextSection [%s] ctrl.posTick=%s, ctrl.value=%s", info.ctrlKind, info.posTick, info.ctrlValue))
			table.insert(nextSection,info)
		end
	end
	return nextSection
end
function initControl()
	local ctrl = {}
	local ret
	for i = 1, #ctrlKind do
		ret = VSSeekToBeginControl(ctrlKind[i])
		while (ret == 1) do
			ret, ctrl = VSGetNextControl(ctrlKind[i])
			if (ret == 1) then
				if (stTick <= ctrl.posTick) and (ctrl.posTick <= edTick) then
					ret = VSRemoveControl(ctrl)
				end
			end
		end
		execLog(string.format("initControl(delete) [%s]", ctrlKind[i]))
	end
end
function pitchByNoteInterval(interval)
	local res = 0
	if (interval > 0) then
		res = math.min(math.floor(8191/cnf.PBS)*interval,8191)
	elseif (interval < 0) then
		res = math.max(math.floor(8192/cnf.PBS)*interval,-8192)
	end
	return res
end
function updateControl()
	local ctrl = {}
	local lastNoteTick, ret
	for i = 1, #ctrlKind do
		for j = 1, #notes-nextSectionFlg do
			ctrl = {}
			ctrl.type = ctrlKind[i]
			if (ctrlKind[i] == "PIT") then
				ctrl.value = pitchByNoteInterval(notes[j].noteNum - keynoteNum)
			elseif (ctrlKind[i] == "PBS") then
				ctrl.value = cnf.PBS
			end
			if (j < #notes-nextSectionFlg) then
				lastNoteTick = notes[j+1].posTick - 1
			else
				lastNoteTick = notes[j].posTick + notes[j].durTick - 1
			end
			for k = notes[j].posTick, lastNoteTick do
				ctrl.posTick = k
				ret = VSInsertControl(ctrl)
			end
			execLog(string.format("updateControl [%s] ctrlTick=%s, ctrlValue=%s, noteBeforeChange=%s", ctrl.type, notes[j].posTick, ctrl.value, getNoteName(notes[j].noteNum)))
		end
	end
end
function drawPitchBend(stTick, edTick)
	local ctrl, angle, shift = {}
	local ret, stValue, edValue, curveTickRatio, curveTimeRatio
	ctrl.type = ctrlKind[1]
	ret, stValue = VSGetControlAt(ctrlKind[1],stTick)
	ret, edValue = VSGetControlAt(ctrlKind[1],edTick)
	if (stValue <= edValue) then -- above
		curveTickRatio = ratio.CURVE_ABOVE_TICK_RATIO
		curveValueRatio = ratio.CURVE_ABOVE_VALUE_RATIO
		angle = {3,0}
		shift = {1,0}
		execLog(string.format("  direction=above, tickMode=%s, valueMode=%s", ratio.CURVE_ABOVE_TICK_RATIO, ratio.CURVE_ABOVE_VALUE_RATIO))
	else -- blow
		curveTickRatio = ratio.CURVE_BELOW_TICK_RATIO
		curveValueRatio = ratio.CURVE_BELOW_VALUE_RATIO
		angle = {1,2}
		shift = {-1,0}
		execLog(string.format("  direction=below, tickMode=%s, valueMode=%s", ratio.CURVE_BELOW_TICK_RATIO, ratio.CURVE_BELOW_VALUE_RATIO))
	end
	execLog(string.format("  startValue=%s, endValue=%s", stValue, edValue))
	local turnPointTick  = math.floor((edTick-stTick)*curveTickRatio)+stTick
	local turnPointValue = math.floor((edValue-stValue)*curveValueRatio)+stValue
	local targetTick = {{st=stTick, ed=turnPointTick}, {st=turnPointTick+1, ed=edTick}}
	local baseTick   = {stTick,turnPointTick}
	local baseValue  = {stValue,turnPointValue}
	local rangeValue = {math.abs(turnPointValue-stValue), math.abs(edValue-turnPointValue)}
	local rangeTick  = {turnPointTick-stTick, edTick-turnPointTick}
	local i, degrees, x, y
	execLog(string.format("  turningTick=%s, turningPitValue=%s", turnPointTick, turnPointValue))
	for i = 1, 2 do -- early, latter
		for x = targetTick[i].st, targetTick[i].ed do
			degrees = (90/rangeTick[i])*(x-baseTick[i])+(angle[i]*90)
			y = baseValue[i]+math.floor((math.sin(math.rad(degrees))+shift[i])*rangeValue[i])
			ctrl.posTick = x
			ctrl.value = y
			ret = VSInsertControl(ctrl)
		end
	end
	return 1
end
function drawSCurve()
	for i = 1, #notes-nextSectionFlg-1 do
		local ret, ctrlTick, rangeTick, bendStTick, bendEdTick
		if (notes[i].noteNum ~= notes[i+1].noteNum) then
			ctrlTick = notes[i+1].posTick - notes[i].posTick
			bendEdTick = notes[i+1].posTick
			ctrlTick = round((ctrlTick/cnf.CURVE_TICK_OVER)*cnf.CURVE_TICK_MAX)
			if (ctrlTick > cnf.CURVE_TICK_OVER) then
				rangeTick = cnf.CURVE_TICK_MAX
			elseif (ctrlTick < cnf.CURVE_TICK_MIN) then
				rangeTick = 0
			else
				if (ctrlTick > cnf.CURVE_TICK_MAX) then
					rangeTick = cnf.CURVE_TICK_MAX
				else
					rangeTick = ctrlTick
				end
			end
			bendStTick = bendEdTick - rangeTick
			if (bendStTick < bendEdTick) then
				execLog("drawSCurve [start]")
				execLog(string.format("  tick=%s, note=%s, bendStart=%s, bendEnd=%s, curveWidth=%s", notes[i+1].posTick, getNoteName(notes[i].noteNum), bendStTick, bendEdTick, rangeTick))
				ret = drawPitchBend(bendStTick, bendEdTick)
				execLog("drawSCurve [end]")
			end
		end
	end
end
function setNextSection()
	if (nextSectionFlg < 1) then
		return 0
	else
		for i = 1, #ctrlKind do
			local ctrl = {}
			local ret
			ctrl.type = nextSection[i].ctrlKind
			ctrl.posTick = nextSection[i].posTick
			ctrl.value = nextSection[i].ctrlValue
			ret = VSInsertControl(ctrl)
			execLog(string.format("setNextSection [%s] ctrl.posTick=%s, ctrl.value=%s", ctrl.type, ctrl.posTick, ctrl.value))
		end
	end
end
function mergeNotes()
	local ret
	for i = 2, #notes-nextSectionFlg do
		ret = VSRemoveNote(notes[i])
		if (ret ~= 1) then
			VSMessageBox("Error: note delete error", 0)
			return 0
		end
		execLog(string.format("mergeNotes noteTick=%s, noteNum=%s", notes[i].posTick, getNoteName(notes[i].noteNum)))
	end
	local firstNote = notes[1]
	firstNote.durTick = edTick- stTick
	firstNote.noteNum = keynoteNum
	ret = VSUpdateNote(firstNote)
	if (ret ~= 1) then
		VSMessageBox("Error: note duration update error", 0)
		return 0
	end
	execLog(string.format("mergeNotes keynoteNum=%s (%s)", getNoteName(keynoteNum), keynoteNum))
end
function main(processParam, envParam)
	beginPosTick = processParam.beginPosTick
	endPosTick   = processParam.endPosTick
	songPosTick  = processParam.songPosTick
	scriptDir    = envParam.scriptDir
	scriptName   = envParam.scriptName
	tempDir      = envParam.tempDir

	--(1)
	manif = manifest()
	appname = manif.name.."_"..manif.pluginVersion
	cnf = readIni(scriptDir..appname..".ini")
	ratioMode = getRatioParam()

	--(2)
	nextSectionFlg, notes, targetCount = getTargetData()

	--(3)
	if (#notes-nextSectionFlg < 2) or (10 < #notes-nextSectionFlg) then
		VSMessageBox("Error: selected ' "..#notes.." ' notes( min:2 max:10 ) or no selection.", 0)
		return 0
	end

	--(4)
	keynoteIndex, aboveRatioMode, belowRatioMode, curveDuration = selKeynoteDialog()
	if (keynoteIndex == nil) or (aboveRatioMode == nil) or (belowRatioMode == nil) or (curveDuration == nil) then
		return 0
	end
	ratio = getRatio(aboveRatioMode, belowRatioMode)
	cnf.CURVE_TICK_MAX = curveDuration

	--(5)
	stTick = notes[1].posTick
	edTick = notes[#notes-nextSectionFlg].posTick + notes[#notes-nextSectionFlg].durTick
	keynoteNum = notes[keynoteIndex].noteNum
	ctrlKind = {"PIT","PBS"}

	--(6)
	if (checkInterval() == 1) then
		VSMessageBox("Error: check notes interval (for "..cnf.PBS.." or less)", 0)
		return 0
	end

	--(7)
	execLog(string.format("\n-- start %s -- (%s)", appname, VSGetSequencePath()))
	nextSection = getNextSection()
	initControl()
	updateControl()
	drawSCurve()
	setNextSection()
	mergeNotes()

	--(8)
	strLogInfo = ""
	if (cnf.LOG_OUTPUT == true) then
		strLogInfo = string.format("\nwrite log file %s",manif.name..".log")
	end
	VSMessageBox("job success!"..strLogInfo, 0)
	execLog(string.format("-- end %s -- (%s)", appname, VSGetSequencePath()))
	return 0
end
